<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('cur', 'quotation');

/**
 * +----------------------------------------------------------
 * 报价列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['quotation']);

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('quotation') . $where . " ORDER BY id DESC";
    
    // 验证并获取合法的分页ID
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 20, $page, 'quotation.php');
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $quotation_list[] = array (
                "id" => $row['id'],
                "contact" => $row['contact'],
                "telphone" => $row['telphone'],
                "content" => $row['content'],
                "status" => $dou->data_lang_format('quotation_status_', $row['status']),
                "ip" => $row['ip'],
                "add_time" => date("Y-m-d", $row[add_time])
        );
    }
    
    $smarty->assign('quotation_list', $quotation_list);
    $smarty->display('quotation.htm');
}

/**
 * +----------------------------------------------------------
 * 计算公式
 * +----------------------------------------------------------
 */
elseif ($rec == 'set') {
    $smarty->assign('ur_here', $_LANG['quotation_set']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['quotation_list'],
            'href' => 'quotation.php' 
    ));
 
    // 默认公式
    $formula = 'if ($mianji >= 90) {
    $zongjia =  ($mianji * 688 + ($wei - 1) * 10500) * 1.10 * 1.0349;
} elseif ($mianji < 90) {
    $zongjia =  ($mianji * 688 + (90 - $mianji) * 499 + ($wei - 1) * 10500) * 1.10 * 1.0349;
}';
   
    // 计算公式
    $set['formula'] = $dou->get_value('fragment', 'text', "mark = 'quotation_formula'");
    if (!isset($set['formula'])) {
        $dou->query("INSERT INTO " . $dou->table('fragment') . " (id, fragment_name, mark, parent_id, text)" . " VALUES (NULL, '装修报价公式', 'quotation_formula', '0', '$formula')");
        
        // 重新加载一次
        $set['formula'] = $dou->get_value('fragment', 'text', "mark = 'quotation_formula'");
    } elseif ($set['formula'] == '') {
        $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$formula' WHERE mark = 'quotation_formula'");
        
        // 重新加载一次
        $set['formula'] = $dou->get_value('fragment', 'text', "mark = 'quotation_formula'");
    }
 
    $parent_id = $dou->get_value('fragment', 'id', "mark = 'quotation_formula'");
 
    // 已有获取装修预算业主数
    $set['number'] = $dou->get_value('fragment', 'text', "mark = 'quotation_number'");
    if (!isset($set['number'])) {
        $dou->query("INSERT INTO " . $dou->table('fragment') . " (id, fragment_name, mark, parent_id, text)" . " VALUES (NULL, '" . $_LANG['quotation_set_number'] . "', 'quotation_number', '$parent_id', '27827')");
        
        // 重新加载一次
        $set['number'] = $dou->get_value('fragment', 'text', "mark = 'quotation_number'");
    } elseif ($set['number'] == '') {
        $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '27827' WHERE mark = 'quotation_number'");
        
        // 重新加载一次
        $set['number'] = $dou->get_value('fragment', 'text', "mark = 'quotation_number'");
    }
 
    // 设计费、工程费、材料费比例
    $set['ratio'] = $dou->get_value('fragment', 'text', "mark = 'quotation_ratio'");
    if (!isset($set['ratio'])) {
        $dou->query("INSERT INTO " . $dou->table('fragment') . " (id, fragment_name, mark, parent_id, text)" . " VALUES (NULL, '" . $_LANG['quotation_set_ratio'] . "', 'quotation_ratio', '$parent_id', '20:20:60')");
        
        // 重新加载一次
        $set['ratio'] = $dou->get_value('fragment', 'text', "mark = 'quotation_ratio'");
    } elseif ($set['ratio'] == '') {
        $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '20:20:60' WHERE mark = 'quotation_ratio'");
        
        // 重新加载一次
        $set['ratio'] = $dou->get_value('fragment', 'text', "mark = 'quotation_ratio'");
    }
 
    // 阿里云短信“模版CODE”
    $set['sms'] = $dou->get_value('fragment', 'text', "mark = 'quotation_sms'");
    if (!isset($set['sms'])) {
        $dou->query("INSERT INTO " . $dou->table('fragment') . " (id, fragment_name, mark, parent_id, text)" . " VALUES (NULL, '" . $_LANG['quotation_set_sms'] . "', 'quotation_sms', '$parent_id', '')");
    }
 
    // 每个IP未读状态报价次数
    $set['limit'] = $dou->get_value('fragment', 'text', "mark = 'quotation_limit'");
    if (!isset($set['limit'])) {
        $dou->query("INSERT INTO " . $dou->table('fragment') . " (id, fragment_name, mark, parent_id, text)" . " VALUES (NULL, '" . $_LANG['quotation_set_limit'] . "', 'quotation_limit', '$parent_id', '3')");
     
        // 重新加载一次
        $set['limit'] = $dou->get_value('fragment', 'text', "mark = 'quotation_limit'");
    }
 
    // 服务提示标语
    $set['slogan'] = $dou->get_value('fragment', 'text', "mark = 'quotation_slogan'");
    if (!isset($set['slogan'])) {
        $dou->query("INSERT INTO " . $dou->table('fragment') . " (id, fragment_name, mark, parent_id, text)" . " VALUES (NULL, '" . $_LANG['quotation_set_slogan'] . "', 'quotation_slogan', '$parent_id', '您还可以获得滴滴免费接驾到店，尊享专业验房师免费为您 上门量房验房、规划户型方案，遇见未来家。')");
     
        // 重新加载一次
        $set['slogan'] = $dou->get_value('fragment', 'text', "mark = 'quotation_slogan'");
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('set', $set);
    $smarty->assign('text', $text);
    
    $smarty->display('quotation.htm');
} 

elseif ($rec == 'set_post') {
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$_POST[formula]' WHERE mark = 'quotation_formula'");
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$_POST[number]' WHERE mark = 'quotation_number'");
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$_POST[ratio]' WHERE mark = 'quotation_ratio'");
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$_POST[sms]' WHERE mark = 'quotation_sms'");
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$_POST[limit]' WHERE mark = 'quotation_limit'");
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = '$_POST[slogan]' WHERE mark = 'quotation_slogan'");
    
    $dou->create_admin_log($_LANG['quotation_set']);
    $dou->dou_msg($_LANG['quotation_set'] . $_LANG['success'], 'quotation.php');
}

/**
 * +----------------------------------------------------------
 * 显示或隐藏
 * +----------------------------------------------------------
 */
elseif ($rec == 'status') {
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';;
    $status = $dou->get_one("SELECT status FROM " . $dou->table('quotation') . " WHERE id = '$id'");
    $status = $status ? 0 : 1;
    
    // 更新报价状态
    $dou->query("UPDATE " . $dou->table('quotation') . " SET status = '$status' WHERE id = '$id'");
    
    $dou->dou_header('quotation.php');
} 

/**
 * +----------------------------------------------------------
 * 批量报价删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del_all') {
    if (is_array($_POST['checkbox'])) {
        $checkbox = $dou->create_sql_in($_POST['checkbox']);
        
        // 删除报价
        $sql = "DELETE FROM " . $dou->table('quotation') . " WHERE id " . $checkbox;
        $dou->query($sql);
        
        $dou->create_admin_log($_LANG['del'] . $_LANG['quotation'] . ": quotation " . addslashes($checkbox));
        $dou->dou_msg($_LANG['del_succes'], 'quotation.php');
    } else {
        $dou->dou_msg($_LANG['select_empty'], 'quotation.php');
    }
}
?>