<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

$sub = 'insert|success';
$subbox = array(
        "module" => 'quotation',
        "sub" => $sub
);

$_CUR = 'quotation';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 开启SESSION
session_start();

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'quotation', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('ur_here', $dou->ur_here('quotation'));
$smarty->assign('head', $_LANG['quotation']);

/**
 * +----------------------------------------------------------
 * 装修报价
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 判断短信验证码
    if ($sms_captcha)
        $smarty->assign("sms_token", $sms->sms_token_set()); // 短信验证码令牌
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('quotation'));
    $smarty->assign('insert_url', $_URL['insert']);
    
    $smarty->display('quotation.dwt');
}

/**
 * +----------------------------------------------------------
 * 报价添加
 * +----------------------------------------------------------
 */
if ($rec == 'insert') {
    // 判断是否为空
    $wrong = $check->fn_empty('quotation', 'contact, telphone, mianji');
 
    // 判断是否含有非法字符
    $wrong = $check->fn_illegal_char('quotation', 'contact, telphone, mianji');
    
    // 验证联系人
    if ($check->is_illegal_char($_POST['telphone'])) {
        $wrong['telphone'] = $_LANG['quotation_telphone'] . $_LANG['illegal_char'];
    } elseif (!$check->is_telphone($_POST['telphone'])) {
        $wrong['telphone'] = $_LANG['quotation_telphone'] . $_LANG['is_wrong'];
    }
    
    // 判断短信验证码
    if ($sms_captcha) {
        if (md5($_POST['sms_captcha'] . DOU_SHELL) != $_SESSION[DOU_ID]['sms']['code'] || $_POST['telphone'] != $_SESSION[DOU_ID]['sms']['telphone']) {
            $wrong['sms_captcha'] = $_LANG['sms_captcha_wrong'];
        } elseif (!$sms->sms_ontime()) { // 判断验证码是否超时
            $wrong['sms_captcha'] = $_LANG['sms_captcha_outtime'];
        } else {
            // 短信验证码为一次性
            unset($_SESSION[DOU_ID]['sms']['code']);
        }
    } else {
        $captcha = $check->is_captcha($_POST['captcha']) ? strtoupper($_POST['captcha']) : '';
        
        // 判断验证码
        if (isset($_POST['captcha']) && $_CFG['captcha'] && md5($captcha . DOU_SHELL) != $_SESSION['captcha'])
            $wrong['captcha'] = $_LANG['captcha_wrong'];
    }
    
    // 错误信息
    if ($wrong) {
        foreach ($_POST as $key => $value) {
            if ($wrong[$key]) {
                $data['wrong'] = $wrong[$key];
                die(json_encode($data));
            }
        }
    }
    
    // 格式化数据
    $ip = $dou->get_ip();
    $add_time = time();
    
    // 检查IP是否频繁报价
    if (is_water($ip)) {
        $data['wrong'] = $_LANG['quotation_is_water'];
        die(json_encode($data));
    }

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    // 计算
    $data = calculate_quotation($_POST['mianji'], $_POST['shi'], $_POST['ting'], $_POST['chu'], $_POST['wei'], $_POST['yangtai']);
    $data['shi'] = $_POST['shi'];
    $data['ting'] = $_POST['ting'];
    $data['chu'] = $_POST['chu'];
    $data['wei'] = $_POST['wei'];
    $data['yangtai'] = $_POST['yangtai'];
    $data['mianji'] = $_POST['mianji'];
    $content = '您的户型：' . $data['shi'] . '室、' . $data['ting'] . '厅、' . $data['chu'] . '厨、' . $data['wei'] . '卫、' . $data['yangtai'] . '阳台，面积：' . $data['mianji'] . 'm²的房子装修预算预估：' . $data['zongjia'] . '元（设计费' . $data['shejifei'] . '元、工程费' . $data['gongchengfei'] . '元、材料费' . $data['cailiaofei'] . '元），最终报价以门店为准。';
    
    // 插入装修报价
    $dou->query("INSERT INTO " . $dou->table('quotation') . " (id, contact, telphone, content, ip, add_time)" . " VALUES (NULL, '$_POST[contact]', '$_POST[telphone]', '$content', '$ip', '$add_time')");
 
    // 增加报价次数
    $dou->query("UPDATE " . $dou->table('fragment') . " SET text = text + 1 WHERE mark = 'quotation_number'");
    
    // 发送短信
    if ($sms_captcha) {
        $templatecode = $GLOBALS['dou']->get_one("SELECT text FROM " . $GLOBALS['dou']->table('fragment') . " WHERE mark = 'quotation_sms'");
        $sms->send_sms($_POST['telphone'], $templatecode, $data); // 发送短信
    }
    
    $data['number'] = $dou->get_value('fragment', 'text', "mark = 'quotation_number'");
    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $unread = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('quotation') . " WHERE ip = '$ip' AND status = 0");
    $limit = $GLOBALS['dou']->get_value('fragment', 'text', "mark = 'quotation_limit'");
    
    // 如果管理员未回复的报价数量大于1
    if ($unread > $limit && $limit > 0)
        return true;
}
 
/**
 * +----------------------------------------------------------
 * 装修报价计算
 * +----------------------------------------------------------
 */
function calculate_quotation($mianji, $shi, $ting, $chu, $wei, $yangtai) {
    $formula = $GLOBALS['dou']->get_value('fragment', 'text', "mark = 'quotation_formula'");
    $ratio = $GLOBALS['dou']->get_value('fragment', 'text', "mark = 'quotation_ratio'");
 
    // 转化为可执行的PHP计算公式
    eval($formula);
    
    // 比例
    $ratio = explode(':', $ratio);
    
    $data['zongjia'] = round($zongjia); // $zongjia是从公式$formula里来的
    $data['shejifei'] = round(($ratio['0'] / 100) * $zongjia);
    $data['gongchengfei'] = round(($ratio['1'] / 100) * $zongjia);
    $data['cailiaofei'] = round(($ratio['2'] / 100) * $zongjia);

    return $data;
}

?>